# mob to mount
tag @s add 302_mount
execute as @e[tag=302_mount] run execute at @s run tag @e[type=minecraft:item,nbt={Item:{id:"minecraft:saddle"}},sort=nearest, limit=1, tag=!302_ignore] add 302_kill

execute as @e[tag=302_kill] on origin if entity @s[distance=8..] run tag @e[tag=302_kill] add 302_ignore
execute as @e[tag=302_kill] on origin if entity @s[distance=8..] run tag @e[tag=302_kill] remove 302_kill


# detect angry neutral
scoreboard objectives add target0 dummy
scoreboard objectives add target1 dummy
scoreboard objectives add target2 dummy
scoreboard objectives add target3 dummy
execute as @a store result score @s target0 run data get entity @s UUID[0]
execute as @a store result score @s target1 run data get entity @s UUID[1]
execute as @a store result score @s target2 run data get entity @s UUID[2]
execute as @a store result score @s target3 run data get entity @s UUID[3]
execute as @e[tag=302_mount, type=#neutral] store result score @s target0 run data get entity @s AngryAt[0]
execute as @e[tag=302_mount, type=#neutral] store result score @s target1 run data get entity @s AngryAt[1]
execute as @e[tag=302_mount, type=#neutral] store result score @s target2 run data get entity @s AngryAt[2]
execute as @e[tag=302_mount, type=#neutral] store result score @s target3 run data get entity @s AngryAt[3]

execute at @a as @e[type=minecraft:item,nbt={Item:{id:"minecraft:saddle"}},sort=nearest,limit=1] on origin if score @e[tag=302_mount, type=#neutral, limit=1] target0 = @s target0 if score @e[tag=302_mount, type=#neutral, limit=1] target1 = @s target1 if score @e[tag=302_mount, type=#neutral, limit=1] target2 = @s target2 if score @e[tag=302_mount, type=#neutral, limit=1] target3 = @s target3 if entity @s[gamemode=!creative] run tag @e[tag=302_mount, type=#neutral, limit=1] add 302_angry
execute at @a as @e[type=minecraft:item,nbt={Item:{id:"minecraft:saddle"}},sort=nearest,limit=1] if entity @e[tag=302_mount, tag=302_angry, distance=..8] on origin run title @s actionbar {"translate":"ride.deny"}
execute as @e[tag=302_mount, tag=302_angry, type=#neutral] run tag @s remove 302_mount
execute as @e[tag=302_angry, type=#neutral] run tag @s remove 302_angry


# detect hostile
execute at @a as @e[tag=302_kill] if entity @e[tag=302_mount, type=#hostile, distance=..8] on origin if entity @s[gamemode=!creative] run title @s actionbar {"translate":"ride.deny"}
execute as @e[tag=302_kill] on origin if entity @s[gamemode=!creative] run execute as @e[tag=302_mount, type=!#neutral, type=!#passive, type=!#weak] run tag @s remove 302_mount

# detect weak and baby
execute at @a as @e[tag=302_kill] if entity @e[tag=302_mount, type=#weak, distance=..8] on origin if entity @s[gamemode=!creative] run tag @e[tag=302_mount, type=#weak, distance=..8] add weak
execute at @a as @e[tag=302_kill] if entity @e[tag=302_mount, predicate=!mount_ride:not_baby, distance=..8] on origin if entity @s[gamemode=!creative] run tag @e[tag=302_mount, predicate=!mount_ride:not_baby, distance=..8] add weak
execute at @a as @e[tag=302_kill] if entity @e[tag=302_mount, tag=weak, distance=..8] on origin run title @s actionbar {"translate":"ride.deny"}
execute as @e[tag=weak] run tag @s remove 302_mount
execute as @e[tag=weak] run tag @s remove weak


# detect distance
execute at @a as @e[tag=302_mount, distance=8..] run tag @s remove 302_mount


# mount
execute at @a as @e[tag=302_kill] if entity @e[tag=302_mount] on origin run ride @s dismount
execute at @a as @e[tag=302_kill] if entity @e[tag=302_mount] on origin run ride @s mount @e[tag=302_mount,limit=1]

execute as @e[tag=302_kill] on origin run give @s saddle 1
execute as @e[tag=302_kill] run kill @s

execute as @e[tag=302_mount] run tag @s remove 302_mount